﻿@model OperationalRiskException.Core.ViewModels.QuestionVM
@{
	ViewBag.Title = "Question";
}


<div class="row">
	<div class="col-md-12 grid-margin">
		<div class="d-flex justify-content-between flex-wrap">
			<div class="d-flex align-items-end flex-wrap">
				<div class="d-flex">
					<i class="mdi mdi-home text-muted hover-cursor"></i>
					<p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Question Management &nbsp;/&nbsp;</p>
					<p class="text-primary mb-0 hover-cursor">Add/View Question</p>
				</div>
			</div>

		</div>
	</div>
</div>

<div class="row">
	<div class="col-md-12">
		<div class="card">
			<div class="card-body">
				<h4 class="card-title"></h4>
				<p class="card-description">Question Type and their format</p>
				<ul class="nav nav-tabs" role="tablist">
					<li class="nav-item">
						<a class="nav-link active" id="nigeria-ho" data-toggle="tab" href="#nigeriaho" role="tab" aria-controls="nigeria-ho" aria-selected="true">

							Numeric Format
						</a>
					</li>
					<li class="nav-item">
						<a class="nav-link" id="nigeria-bo" data-toggle="tab" href="#nigeriabo" role="tab" aria-controls="nigeriabo" aria-selected="false" >

						  Choice Format
						</a>
					</li>
					<li class="nav-item">
						<a class="nav-link" id="africa-ho" data-toggle="tab" href="#africaho" role="tab" aria-controls="africaho" aria-selected="false" >Yes/NO Format</a>
					</li>
				   
				</ul>
				<div class="tab-content">
					<div class="tab-pane fade show active" id="nigeriaho" role="tabpanel" aria-labelledby="nigeria-ho">
						<div class="row ">
							<div class="col-md-12">
								<div class="card">
									<div class="card-body">
										<h4 class="card-title"> Create Question </h4>
										<p class="card-description">

										</p>

										@using (Html.BeginForm("QuestionPage", "Question", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
										{
											@Html.AntiForgeryToken()

									<div class="row">
										@Html.HiddenFor(m => m.QuestionType, new { Value = "0" })
										
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Question  Text</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.QuestionText, new { @class = "form-control", @placeholder = "Add Question" })
												@Html.ValidationMessageFor(model => model.QuestionText, null, new { @class = "text text-danger" })
											</div>
										</div>
									   
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Question Answer</label>
											<div class="row col-md-6">
												@Html.EditorFor(model => model.NumericAnswer, new { htmlAttributes = new { @type = "number", @min = "0", @step = "0.01", @value = "0", @class = "form-control", @placeholder = "Numeric Question Answer" } })
											   @* @Html.TextAreaFor(m => m.NumericAnswer, new { type = "number", min = "0", step = "0.01", @class = "form-control", @placeholder = "Numeric Question Answer" })*@
												@Html.ValidationMessageFor(model => model.NumericAnswer, null, new { @class = "text text-danger" })
											</div>
										</div>
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1"> Select Category</label>
											<div class="row col-md-6">
												@Html.DropDownListFor(m => m.CategoryId, new SelectList(ViewBag.Categories, "CategoryId", "CategoriesName"), new { @class = "form-control", @placeholder = "Add Question" })
												@Html.ValidationMessageFor(model => model.CategoryId, null, new { @class = "text text-danger" })
											</div>
										</div>

									</div>



											<button type="submit" class="btn btn-primary mr-2">Add Question</button>
										}
									</div>
								</div>
							</div>
						</div>
						@*@Html.Partial("_userTable", "nigeriaHOTable")*@


					</div>

					@*This section is for adding question choice format*@

					<div class="tab-pane fade" id="nigeriabo" role="tabpanel" aria-labelledby="nigeria-bo">

						<div class="row ">
							<div class="col-md-12">
								<div class="card">
									<div class="card-body">
										<h4 class="card-title"> Create Question </h4>
										<p class="card-description">

										</p>


										@using (Html.BeginForm("QuestionPage", "Question", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
										{
											@Html.AntiForgeryToken()

									<div class="row">
										@*Numerical,
		Options,
		YesNoType,*@
										@Html.HiddenFor(m => m.QuestionType, new { Value = "1" })
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Question  Text</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.QuestionText, new { @class = "form-control", @placeholder = "Add Question" })
												@Html.ValidationMessageFor(model => model.QuestionText, null, new { @class = "text text-danger" })
											</div>
										</div>

										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Answer Text(A)</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.AnswerTextA, new { @class = "form-control", @placeholder = "Answer Text(A)" })
												@Html.ValidationMessageFor(model => model.AnswerTextA, null, new { @class = "text text-danger" })
											</div>
										</div>
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Answer Text(B)</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.AnswerTextB, new { @class = "form-control", @placeholder = "Answer Text(B)" })
												@Html.ValidationMessageFor(model => model.AnswerTextB, null, new { @class = "text text-danger" })
											</div>
										</div>
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Answer Text(C)</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.AnswerTextC, new { @class = "form-control", @placeholder = "Answer Text(C)" })
												@Html.ValidationMessageFor(model => model.AnswerTextC, null, new { @class = "text text-danger" })
											</div>
										</div>

										<div class="form-group col-md-12">
											<label for="exampleInputUsername1">Answer Text(D)</label>
											<div class="row col-md-6">
												@Html.TextAreaFor(m => m.AnswerTextD, new { @class = "form-control", @placeholder = "Answer Text(D)" })
												@Html.ValidationMessageFor(model => model.AnswerTextD, null, new { @class = "text text-danger" })
											</div>
										</div>
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1"> Select the right choice </label>
											<div class="row col-md-6">
												@Html.EnumDropDownListFor(model => model.ChoiceAnswer, new { @class = "form-control" })
											</div>
										</div>
										<div class="form-group col-md-12">
											<label for="exampleInputUsername1"> Select Category</label>
											<div class="row col-md-6">
												@Html.DropDownListFor(m => m.CategoryId, new SelectList(ViewBag.Categories, "CategoryId", "CategoriesName"), new { @class = "form-control", @placeholder = "Add Question" })
												@Html.ValidationMessageFor(model => model.CategoryId, null, new { @class = "text text-danger" })
											</div>
										</div>


									</div>



											<button type="submit" class="btn btn-primary mr-2">Add Question</button>
										}


									</div>
								</div>
							</div>
						</div>
							@*@Html.Partial("_userTable", "nigeriaBOTable")*@

						</div>
					<div class="tab-pane fade" id="africaho" role="tabpanel" aria-labelledby="africa-ho">
						<div class="row ">
							<div class="col-md-12">
								<div class="card">
									<div class="card-body">
										<h4 class="card-title"> Create Question </h4>
										<p class="card-description">

										</p>

										@using (Html.BeginForm("QuestionPage", "Question", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
										{
											@Html.AntiForgeryToken()
											@Html.HiddenFor(m => m.QuestionType, new { Value = "2" });
											<div class="row">
											   
												<div class="form-group col-md-12">
													<label for="exampleInputUsername1">Question  Text</label>
													<div class="row col-md-6">
														@Html.TextAreaFor(m => m.QuestionText, new { @class = "form-control", @placeholder = "Add Question" })
														@Html.ValidationMessageFor(model => model.QuestionText, null, new { @class = "text text-danger" })
													</div>
												</div>
												<div class="form-group col-md-12">
													<label for="exampleInputUsername1"> Select Category</label>
													<div class="row col-md-6">
														@Html.DropDownListFor(m => m.CategoryId, new SelectList(ViewBag.Categories, "CategoryId", "CategoriesName"), new { @class = "form-control", @placeholder = "Add Question" })
													</div>
												</div>

											</div>



											<button type="submit" class="btn btn-primary mr-2">Add Question</button>
										}
									</div>
								</div>
							</div>
							</div>
							


						</div>
				 
				</div>
			</div>
		</div>
	</div>
</div>







<div class="row">
	<div class="col-md-12 grid-margin stretch-card">
		<div class="card tablecontainer">
			<div class="card-body">
				<h4 class="card-title"></h4>
				<p class="card-description">
					List of Questions
				</p>
				<div class="table-responsive pt-3">
					<table class="table table-bordered" id="myTable">
						<thead class="table-dark" >
							<tr>
								<th>
									Id
								</th>
								<th>
									S/N
								</th>
								<th>
									Question Content
								</th>
								<th>
									Category Name
								</th>
								<th>
									Question Type
								</th>
								<th>
									AnswerText (A)
								</th>
								<th>
									AnswerText (B)
								</th>
								<th>
									AnswerText (C)
								</th>
								<th>
									AnswerText (D)
								</th>
								<th>
									NumericAnswer
								</th>
								<th>
									ChoiceAnswerText
								</th>
								<th>
									Edit
								</th>
								<th>
									Delete
								</th>

							</tr>
						</theadclass="table-dark">
						<tbody></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<div id="userModal" class="modal fade">
	<div class="modal-dialog">
		<div class="modal-content" id="userModalBody">

		</div>
	</div>
</div>

<script type="text/javascript">
    function updateModal(userId, questionType) {
        if (questionType == 0) {
            $.get('@Url.Action("UpdateQuestionNumeric", "Question")', { Id: userId }, function (res) {
                $("#userModalBody").html(res);
                $("#userModal").modal("show");
            });
        }
        else if (questionType == 1) {
            $.get('@Url.Action("UpdateQuestionOption", "Question")', { Id: userId }, function (res) {
                $("#userModalBody").html(res);
                $("#userModal").modal("show");
            });
        }
        else if(questionType == 2) {
			   $.get('@Url.Action("UpdateQuestion", "Question")', { Id: userId }, function (res) {
                $("#userModalBody").html(res);
                $("#userModal").modal("show");
            });
        }
		
	}	
	 function deleteModal(userId) {
		$.get('@Url.Action("DeleteQuestion", "Question")', { Id: userId }, function (res) {
			$("#userModalBody").html(res);
			$("#userModal").modal("show");
		   // oTable.ajax.reload();
		});
	}
	var oTable;
	$(document).ready(function () {
		//  debugger;
		 toastrFunction()
		 oTable = $("#myTable").DataTable({
			"processing": true, // for show progress bar
			"serverSide": true, // for process server side
			"filter": true, // this is for disable filter (search box)
             "orderMulti": false, // for disable multiple column at once

			 //----------------chuks
			 //"searchable": false,
    //        "orderable": false,
    //        "targets": 0
             columns: [

                 { 'data': 'QuestionId', 'orderable': false, visible: false },
				 {'data':'S/N',  render: function (data, type, full, meta) {

                     console.log("type", type)
                     console.log("full", full)
                     console.log("meta", meta.settings._iDisplayLength)
					 
					  console.log("_iDisplayStart", meta.settings._iDisplayStart)
				
                        var result = meta.row +1 +(meta.settings._iDisplayStart);
                      
                     return result;
                 }
                 },
                { 'data': 'QuestionText' },
				  { 'data': 'CategoryName' },

				{ 'data': 'QuestionTypeText' },
				{ 'data': 'AnswerTextA' },
				{ 'data': 'AnswerTextB' },
				{ 'data': 'AnswerTextC' },
				{ 'data': 'AnswerTextD' },
				{ 'data': 'NumericAnswer' },
                {
                    'data': 'ChoiceAnswerText', render: function (data, type, full) {

                        var result = '-';
                        if (full.QuestionType == 1) {

                            result = data;
                        }
                        return result;
                    }
                },


				{
					"data": "QuestionId", "width": "50px", "render": function (data, type, full) {
						//	return '<button class="btn btn-primary btn-lg" style="min-height:2rem" onclick="updateModal(' + data+ ')">Edit</button>';
	   return '<button class="btn btn-primary btn-lg" style="min-height:2rem" onclick="updateModal(\'' + data + '\',\'' + full.QuestionType + '\');">Edit</button>';
	   
					   // return '<a class="popup" href="@Url.Action("UpdateQuestion","Question")/' + data + '">Edit</a>';  
					}
				},
				{
					"data": "QuestionId", "width": "50px", "render": function (data) {
						return '<button class="btn btn-danger btn-lg" style="min-height:2rem" onclick="deleteModal(' + data+ ')">Delete</button>';
			   
					   // return '<a class="popup" href="@Url.Action("DeleteQuestion","Question")/' + data + '">Delete</a>'; 
					}
				}
				@*{
					data: null,
					//className: "center",
					//defaultContent: '<a href="" class="editor_edit">Edit</a> / <a href="" class="editor_remove">Delete</a>'
  },

			],
			"columnDefs": [{
				"targets": 4,

				"render": function (data, type, row, meta) {
					var url = '@Url.Action("AddUser", "Usercd")';
					return "'<a href='"url"'>Testing</a>'";
				}
			}],*@
             ],
			 //------------------ chuks implementaion
			// "order": [[ 1, 'asc' ]]

			"delay": 150,
			"ajax": {
				"url": "@Url.Action("GetAllQuestions","Question")", 
				"type": "POST",
				"datatype": "json"
			}
         })	


    });

	//----------------------- Chuks Implementation

	 //oTable.on( 'order.dt search.dt', function () {
  //      oTable.column(0, {search:'applied', order:'applied'}).nodes().each( function (cell, i) {
  //          cell.innerHTML = i+1;
  //      } );
  //  } ).draw();
  //  });

	 function updateRecordNumeric() {
					var form = $('form[name="updateCategoryForm"]');
		 var entry = form.serialize();
		 $.post('@Url.Action("UpdateQuestionNumeric", "Question")', entry, function (res) {  
			if (res.status) {
				toastr.success("Successfully Updated", "Notification");

				oTable.ajax.reload();
				$("#userModal").modal('hide');
			}
			else {
				toastr.error("Failed to update, <br> Please check if the record already existed", "Error Notification");
			}
		   //
		});
    }
	
	 function updateRecord() {
					var form = $('form[name="updateCategoryForm"]');
		 var entry = form.serialize();
		 $.post('@Url.Action("UpdateQuestion", "Question")', entry, function (res) {  
			if (res.status) {
				toastr.success("Successfully Updated", "Notification");

				oTable.ajax.reload();
				$("#userModal").modal('hide');
			}
			else {
				toastr.error("Failed to update, <br> Please check if the record already existed", "Error Notification");
			}
		   //
		});
    }
	
	 function updateRecordOption() {
					var form = $('form[name="updateCategoryForm"]');
		 var entry = form.serialize();
		 $.post('@Url.Action("UpdateQuestionOption", "Question")', entry, function (res) {  
			if (res.status) {
				toastr.success("Successfully Updated", "Notification");

				oTable.ajax.reload();
				$("#userModal").modal('hide');
			}
			else {
				toastr.error("Failed to update, <br> Please check if the record already existed", "Error Notification");
			}
		   //
		});
	}
		 function deleteRecord() {
					var form = $('form[name="deleteCategoryForm"]');
		 var entry = form.serialize();
		 $.post('@Url.Action("DeleteQuestion", "Question")', entry, function (res) {  
			if (res.status) {
				toastr.success("Successfully Delete", "Notification");

				oTable.ajax.reload();
				$("#userModal").modal('hide');
			}
			else {
				toastr.error("Failed to update, <br> Please check your internet connnection", "Error Notification");
			}
		   //
		});
	}
	   function toastrFunction() {

		 if ('@TempData["CreateQuest"]'.length > 1) {
		  toastr.success('@TempData["CreateQuest"]','Notification');
		 }
		 else  if ('@TempData["FailedQuest"]'.length>1) {
		  toastr.error('@TempData["FailedQuest"]','Notification');
	   }

	}

</script>
